#include "indexer.h"

Indexer::Indexer(QObject *parent) :
    QThread(parent)
{
}

void Indexer::run()
{
    totalFiles = 0;
    totalFolders = 0;

    idx_folder = parseDir(directory);
}



Folder Indexer::getFolder(QString id)
{
    Folder folder = idx_folder;
    QList<QString> addr = id.split(':');

    for(int i = 0; i < addr.size(); i++)
    {
        if(addr.at(i).size() > 0){
        bool ok;
        int idx = addr.at(i).toInt(&ok);
                  if(ok){
                  folder = folder.folders.at(idx);
              }
    }
    }
    return folder;
}

void Indexer::indexDir(QString dir)
{
directory = dir;
this->start();
}

Folder Indexer::parseDir(QString dirPath)
{
    Folder folder;
    folder.name = dirPath;

     QDir dir;
     dir.setFilter(QDir::Dirs | QDir::Files | QDir::Hidden | QDir::NoDotAndDotDot);
     dir.setPath(dirPath);
     QList<QFileInfo> list = dir.entryInfoList();

     for(int i = 0;i<list.size();i++)
     {
         if(list.at(i).isDir())
         {
             folder.folders.append(parseDir(list.at(i).absoluteFilePath()));
         } else {
             File file;
             file.size = list.at(i).size();
             file.name = list.at(i).fileName();
             folder.files.append(file);
         }
     }

     totalFiles += folder.files.size();
     totalFolders += folder.folders.size();

calculateFolderSize(&folder);

return folder;

}



void Indexer::calculateFolderSize(Folder *folder)
{
    qint64 filesSize = 0;
    qint64 foldersSize = 0;
    qint64 items = 0;

    for(int i = 0; i < folder->files.size();i++)
    {
     filesSize += folder->files.at(i).size;
    }

    for(int i = 0; i < folder->folders.size();i++)
    {
       foldersSize += folder->folders.at(i).size;
       items += folder->folders.at(i).items + 1; // 1, we add the folder as well as it's items;
    }

    folder->items = items + folder->files.size();
    folder->size = foldersSize + filesSize;
    folder->filesSize = filesSize;
    folder->foldersSize = foldersSize;
}

